global.uuid = global.uuid || require('../../static_dependencies/uuid/uuid-random.min.js')

/**
   * UID class
   *
   * @author jsb4ch <jsb4ch@jsmex.io>
   * @since 1.0.0
  */
class UID {
  /**
   * UID create method
   *
   * @author jsb4ch <jsb4ch@jsmex.io>
   * @since 1.0.0
   * @returns string
  */
  static create (options = {}) {
    options.uuidVersion = options.uuidVersion || 'v4'
    options.setHeader = options.setHeader === undefined || !!options.setHeader
    options.headerName = options.headerName || 'X-Request-Id'
    options.attributeName = options.attributeName || 'id'
    return global.uuid(options, options.buffer, options.offset)
  }

  /**
   * UID isValid method
   *
   * @author jsb4ch <jsb4ch@jsmex.io>
   * @since 1.0.0
   * @returns boolean
  */
  static isValid (uid) {
    return global.uuid.test(uid)
  }
}

module.exports = UID
